﻿using UnityEngine;
using System.Collections;

public class rotationDebug : MonoBehaviour {

	Transform playerPosition;
	public float rotation_speed = 1.0f;
	public float speed = 1.0f;


	public GameObject projectile;
	GameObject[] projectiles;
	int maxProjectile = 2;
	public GameObject barrel;

	public float startFireTime = 1.0f;
	public float repeatFireTime = 1.0f;

	public gameManager gMANAGER;



	void Awake(){

		gMANAGER = GameObject.FindWithTag ("GM").GetComponent<gameManager> ();
		playerPosition = GameObject.FindWithTag ("Player").GetComponent<Transform> ();

	}

	
	void Start () {
	

		projectiles = new GameObject[maxProjectile];
		
		for (int i = 0; i < maxProjectile; i++) {
			
			projectiles[i] = Instantiate(projectile);
			projectiles[i].SetActive(false);
			
			
		}

		//InvokeRepeating ("Fire", startFireTime, repeatFireTime);

	}


	void OnEnable(){
		InvokeRepeating ("Fire", startFireTime, repeatFireTime);
	}
	void OnDisable(){
		CancelInvoke();
	}

	void Fire(){
		
		for(int i = 0; i < maxProjectile; i++){
			
			if(!projectiles[i].activeInHierarchy){
				
				projectiles[i].transform.position = barrel.transform.position;
				projectiles[i].transform.rotation = barrel.transform.rotation;
				projectiles[i].SetActive(true);
				break;
				
			}
			
		}
		
	}

	void Update () {



		float angle = Mathf.Atan2 ((playerPosition.position.y - transform.position.y), (playerPosition.position.x - transform.position.x)) * Mathf.Rad2Deg;
		Quaternion rotation = Quaternion.Euler (0, 0, angle + 90);
		transform.rotation = Quaternion.Lerp (transform.rotation, rotation, rotation_speed * Time.deltaTime);

		transform.position = Vector2.MoveTowards (transform.position, playerPosition.position, speed * Time.deltaTime);

	}


	void OnTriggerEnter2D(Collider2D coll){

		if (coll.gameObject.tag == "PBullet") {

			gMANAGER.enemyKilled ();
			coll.gameObject.SetActive (false);
			gameObject.SetActive (false);

		} else if (coll.gameObject.tag == "Player") {


			gMANAGER.damagePlayer(2);
			gameObject.SetActive(false);

		}

	}
}
